<TeXmacs|1.99.11>

<style|<tuple|beamer|vdh|wide-spacing|shadowed-frames|shadowed-titles|std-frame|dark-vador|framed-theorems|caas>>

<\body>
  <\hide-preamble>
    <assign|font|mathlarge=TeX Gyre Pagella,Fira>

    \;

    <assign|rsC|<macro|<with|font|cal*|C>>>

    <assign|rsT|<macro|<with|font|cal*|T>>>

    <assign|marked|<macro|body|<tabular*|<tformat|<cwith|1|1|1|1|cell-background|dark
    grey>|<cwith|1|1|1|1|cell-bsep|0.25spc>|<cwith|1|1|1|1|cell-tsep|0.25spc>|<cwith|1|1|1|1|cell-lsep|1spc>|<cwith|1|1|1|1|cell-rsep|1spc>|<table|<row|<cell|<arg|body>>>>>>>>

    \;

    <assign|compressed|<\macro|body>
      <\surround||<right-flush>>
        <\with|par-par-sep|<times|0.4|<value|par-par-sep>>>
          <arg|body>
        </with>
      </surround>
    </macro>>

    \;

    <assign|render-specified-algorithm|<\macro|name|intro|body>
      <\padded*>
        <\with|par-first|0fn|par-par-sep|0.3em|item-hsep|<macro|1tab>|numbered-offset|<value|algorithm-numbered-offset>>
          <\surround||<vspace|0.5fn>>
            <algorithm-name|<arg|name>>

            <arg|intro>
          </surround>

          <\surround||<yes-indent*>>
            <\algorithm-indent>
              <arg|body>
            </algorithm-indent>
          </surround>
        </with>
      </padded*>
    </macro>>
  </hide-preamble>

  <screens|<\shown>
    <\with|par-mode|center>
      <tabular*|<tformat|<cwith|1|2|1|1|cell-bsep|2.5spc>|<cwith|5|5|1|1|cell-halign|r>|<cwith|5|5|1|1|cell-hyphen|t>|<cwith|3|3|1|1|cell-tsep|3spc>|<cwith|1|1|1|1|cell-bsep|2spc>|<cwith|1|1|1|1|cell-tsep|4spc>|<cwith|2|2|1|1|cell-tsep|4spc>|<table|<row|<cell|<huge|<strong|<with|color|orange|Sparse
      polynomial interpolation>>>>>|<row|<cell|<tabular*|<tformat|<twith|table-valign|T>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|1|1|1|1|cell-tsep|1spc>|<table|<row|<cell|>>>>>
      <large|<tabular*|<tformat|<twith|table-valign|T>|<cwith|2|2|1|1|cell-bsep|0spc>|<cwith|2|2|1|1|cell-tsep|0spc>|<table|<row|<cell|<space|2em><strong|Joris
      van der Hoeven><space|2em>>>|<row|<cell|<small|CNRS, visiting professor
      at PIMS and SFU>>>|<row|<cell|<small|Joint work with Grgoire
      Lecerf>>>>>>>>>|<row|<cell|<tabular*|<tformat|<cwith|1|1|1|1|cell-background|<pattern|/Users/vdhoeven/sdk-clang/src/TeXmacs/misc/patterns/vintage/metal-rough-light.png||>>|<cwith|1|1|1|1|cell-lsep|1spc>|<cwith|1|1|1|1|cell-rsep|1spc>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|1|1|1|1|cell-tsep|1spc>|<table|<row|<cell|<image|transparent-texmacs-chip.png|0.43par|||>>>>>>>>|<row|<cell|<space|0.9par>>>|<row|<\cell>
        <small|<strong|SFU, Vancouver>><htab|5mm><small|<strong|December 3,
        2019>>
      </cell>>>>>
    </with>
  </shown>|<\hidden>
    <em|>

    \;

    \;

    \;

    <\with|par-right|2tab|par-left|2tab>
      <\ornamented>
        <\ornamented>
          \;

          <center|<with|frame-recolor|#fa6|<\center>
            <larger|<strong|Part I>>

            Statement of the problem
          </center>>>

          \;
        </ornamented>
      </ornamented>
    </with>

    \;

    \;

    \;
  </hidden>|<\hidden>
    <tit|Black box functions and their interpolation>

    \;

    <unroll|<\shown>
      <strong|Input>

      <with|gr-mode|<tuple|group-edit|move>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.339129par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect-props|<tuple|<tuple|axes|dark
      grey>|<tuple|1|dark grey>|<tuple|4|darker
      grey>>|gr-grid-aspect|<tuple|<tuple|axes|dark grey>|<tuple|1|dark
      grey>|<tuple|4|darker grey>>|gr-color|pastel
      yellow|gr-arrow-end|\<gtr\>|gr-text-at-halign|center|gr-text-at-valign|center|<graphics||<with|color|pastel
      yellow|text-at-valign|center|text-at-halign|center|<text-at|<with|shadow-blur-radius|5ln|shadow-dy|0ln|shadow-dx|0ln|<shadow|<image|closed_box.png|8cm|||>>>|<point|0|0>>>|<with|color|pastel
      yellow|text-at-valign|axis|text-at-halign|right|<math-at|\<alpha\><rsub|1>,\<ldots\>,\<alpha\><rsub|n>|<point|-6.25|-1.0>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|-5.5|-0.75>|<point|-1.99204590554306|-0.136724434449001>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|3.22173898663844|0.762203995237465>|<point|5.86879731479517|1.25>>>|<with|color|pastel
      yellow|text-at-valign|axis|<math-at|f<around*|(|\<alpha\><rsub|1>,\<ldots\>,\<alpha\><rsub|n>|)>|<point|6.5|1.5>>>|<with|color|pastel
      yellow|text-at-valign|center|text-at-halign|center|<math-at|f|<point|1.33399787273449|0.257376057679587>>>>>

      \;
    </shown>|<\hidden*>
      <strong|Output>

      <\equation*>
        f<around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>=c<rsub|1>*x<rsub|1><rsup|e<rsub|1,1>>*\<cdots\>*x<rsub|n><rsup|e<rsub|1,n>>+\<cdots\>+c<rsub|t>*x<rsub|1><rsup|e<rsub|t,1>>*\<cdots\>*x<rsub|n><rsup|e<rsub|t,n>>
      </equation*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Example>

    \;

    <unroll|<\shown>
      <strong|Input>

      <switch|<\shown>
        <with|gr-mode|<tuple|group-edit|move>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.339129par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect-props|<tuple|<tuple|axes|dark
        grey>|<tuple|1|dark grey>|<tuple|4|darker
        grey>>|gr-grid-aspect|<tuple|<tuple|axes|dark grey>|<tuple|1|dark
        grey>|<tuple|4|darker grey>>|gr-color|pastel
        yellow|gr-arrow-end|\<gtr\>|gr-text-at-halign|center|gr-text-at-valign|center|<graphics||<with|color|pastel
        yellow|text-at-valign|center|text-at-halign|center|<text-at|<with|shadow-blur-radius|5ln|shadow-dy|0ln|shadow-dx|0ln|<shadow|<image|closed_box.png|8cm|||>>>|<point|0|0>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|-5.5|-0.75>|<point|-1.99204590554306|-0.136724434449001>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|3.22173898663844|0.762203995237465>|<point|5.86879731479517|1.25>>>|<with|color|pastel
        yellow|text-at-valign|axis|<math-at|<with|math-display|true|<det|<tformat|<table|<row|<cell|\<alpha\><rsub|1,1>>|<cell|\<alpha\><rsub|1,2>>|<cell|\<alpha\><rsub|1,3>>>|<row|<cell|\<alpha\><rsub|2,1>>|<cell|\<alpha\><rsub|2,2>>|<cell|\<alpha\><rsub|2,3>>>|<row|<cell|\<alpha\><rsub|3,1>>|<cell|\<alpha\><rsub|3,2>>|<cell|\<alpha\><rsub|3,3>>>>>>>|<point|6.16471802487101|1.5758>>>|<with|color|pastel
        yellow|text-at-valign|axis|text-at-halign|right|<math-at|\<alpha\><rsub|1,1>,\<alpha\><rsub|1,2>,\<alpha\><rsub|1,3>,|<point|-5.66099632623363|0.04114300403493>>>|<with|color|pastel
        yellow|text-at-halign|right|text-at-valign|axis|<math-at|\<alpha\><rsub|2,1>,\<alpha\><rsub|2,2>,\<alpha\><rsub|2,3>,|<point|-5.66099632623363|-0.95885699596507>>>|<with|color|pastel
        yellow|text-at-valign|axis|text-at-halign|right|<math-at|\<alpha\><rsub|3,1>,\<alpha\><rsub|3,2>,\<alpha\><rsub|3,3><phantom|,>|<point|-5.66099632623363|-1.95885699596507>>>|<with|color|pastel
        yellow|text-at-valign|center|text-at-halign|center|<math-at|f|<point|1.33399787273449|0.257376057679587>>>>>
      </shown>|<\hidden>
        <with|gr-mode|<tuple|group-edit|move>|gr-frame|<tuple|scale|1cm|<tuple|0.5gw|0.5gh>>|gr-geometry|<tuple|geometry|1par|0.339129par|center>|gr-grid|<tuple|empty>|gr-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-edit-grid-aspect|<tuple|<tuple|axes|none>|<tuple|1|none>|<tuple|4|none>>|gr-edit-grid|<tuple|empty>|gr-edit-grid-old|<tuple|cartesian|<point|0|0>|1>|gr-grid-aspect-props|<tuple|<tuple|axes|dark
        grey>|<tuple|1|dark grey>|<tuple|4|darker
        grey>>|gr-grid-aspect|<tuple|<tuple|axes|dark grey>|<tuple|1|dark
        grey>|<tuple|4|darker grey>>|gr-color|pastel
        yellow|gr-arrow-end|\<gtr\>|gr-text-at-halign|center|gr-text-at-valign|center|<graphics||<with|color|pastel
        yellow|text-at-valign|center|text-at-halign|center|<text-at|<with|shadow-blur-radius|5ln|shadow-dy|0ln|shadow-dx|0ln|<shadow|<image|open_box.png|8cm|||>>>|<point|0|0>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|-5.5|-0.75>|<point|-1.99204590554306|-0.136724434449001>>>|<with|color|#a66|arrow-end|\<gtr\>|line-width|2ln|<line|<point|3.22173898663844|0.762203995237465>|<point|5.86879731479517|1.25>>>|<with|color|pastel
        yellow|text-at-valign|axis|<math-at|<with|math-display|true|<det|<tformat|<table|<row|<cell|\<alpha\><rsub|1,1>>|<cell|\<alpha\><rsub|1,2>>|<cell|\<alpha\><rsub|1,3>>>|<row|<cell|\<alpha\><rsub|2,1>>|<cell|\<alpha\><rsub|2,2>>|<cell|\<alpha\><rsub|2,3>>>|<row|<cell|\<alpha\><rsub|3,1>>|<cell|\<alpha\><rsub|3,2>>|<cell|\<alpha\><rsub|3,3>>>>>>>|<point|6.16471802487101|1.5758>>>|<with|color|pastel
        yellow|text-at-valign|axis|text-at-halign|right|<math-at|\<alpha\><rsub|1,1>,\<alpha\><rsub|1,2>,\<alpha\><rsub|1,3>,|<point|-5.66099632623363|0.04114300403493>>>|<with|color|pastel
        yellow|text-at-halign|right|text-at-valign|axis|<math-at|\<alpha\><rsub|2,1>,\<alpha\><rsub|2,2>,\<alpha\><rsub|2,3>,|<point|-5.66099632623363|-0.95885699596507>>>|<with|color|pastel
        yellow|text-at-valign|axis|text-at-halign|right|<math-at|\<alpha\><rsub|3,1>,\<alpha\><rsub|3,2>,\<alpha\><rsub|3,3><phantom|,>|<point|-5.66099632623363|-1.95885699596507>>>|<with|color|pastel
        yellow|text-at-valign|center|text-at-halign|center|<text-at|<stack|<tformat|<table|<row|<cell|Gaussian>>|<row|<cell|elimination>>>>>|<point|0.0155609207567139|2.86426776028575>>>|<with|color|pastel
        yellow|text-at-valign|center|text-at-halign|center|<math-at|f|<point|1.33399787273449|0.257376057679587>>>>>
      </hidden>>

      \;
    </shown>|<\hidden*>
      <strong|Output>

      <\equation*>
        x<rsub|1,1>*x<rsub|2,2>*x<rsub|3,3>-x<rsub|1,1>*x<rsub|2,3>*x<rsub|3,2>+x<rsub|1,2>*x<rsub|2,3>*x<rsub|3,1>-x<rsub|1,2>*x<rsub|2,1>*x<rsub|3,3>+x<rsub|1,3>*x<rsub|2,1>*x<rsub|3,2>-x<rsub|1,3>*x<rsub|2,2>*x<rsub|3,1>
      </equation*>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Variants>

    <\compressed>
      <unroll|<\shown>
        <strong|Coefficients <math|K>>

        <\itemize>
          <item>A field from analysis such as <math|K=\<bbb-C\>>.

          <item>A discrete field such as <math|K=\<bbb-Q\>> or a finite field
          <math|K=\<bbb-F\><rsub|q>>.

          <item>Roots of unity <math|\<omega\>> of large smooth order in
          <math|K>?
        </itemize>
      </shown>|<\hidden*>
        <strong|Complexity model>

        <\itemize>
          <item>Algebraic <em|versus> bit complexity.

          <item>Deterministic (needs bounds) <em|versus> probabilistic.

          <item>Theoretic (asymptotic) <em|versus> practical complexity.

          <item>Divisions in <math|K> allowed for evaluation of
          <math|f><space|0.6spc>?

          <item>Allow evaluations at points in <math|A<rsup|n>> for extension
          <math|A\<supseteq\>K><space|0.6spc>?
        </itemize>
      </hidden*>|<\hidden*>
        <strong|How sparse?>

        <\itemize>
          <item><with|color|#fa6|Weakly sparse>: total degrees <math|d> of
          the order <math|O<around*|(|log t|)>>.

          <item><with|color|#fa6|Normally sparse>: total degrees <math|d> of
          the order <math|t<rsup|O<around*|(|1|)>>>.

          <item><with|color|#fa6|Super sparse>: total degrees of order
          <math|d> with <math|log t=o<around*|(|log d|)>>.
        </itemize>
      </hidden*>>
    </compressed>

    \;
  </hidden>|<\hidden>
    <tit|Short history>

    <unroll|<\shown>
      <strong|Old work>

      <\itemize>
        <item>Prony [1795]

        <item>Zippel [1979, 1990]
      </itemize>
    </shown>|<\hidden*>
      <strong|Rediscovery and early work in computer algebra>

      <\itemize>
        <item>Ben-Or Tiwari [1988]

        <item>Kaltofen-Yagati [1988], Canny-Kaltofen-Lakshman [1989],
        Kaltofen-Trager [1990], Kaltofen-Lakshman-Wiley [1990]

        <item>Huang-Rao [1996], Murao-Fujise [1996]
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Early implementations>

      <\itemize>
        <item>Diaz-Kaltofen [1988] FOXFOX

        <item>Freeman-Imirzian-Kaltofen-Lakshman [1988] Dagwood
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Short history continued<text-dots>>

    <unroll|<\shown>
      <strong|Recent work>

      <\itemize>
        <item>Garg-Schost [2009]

        <item>Javadi-Monagan [2010], Hu-Monagan [2013, 2016], Monagan-Tuncer
        [2015, 2019], Monagan-Wong [2016]

        <item>Giesbrecht-Roche [2011], Arnold-Giesbrecht-Roche [2014, 2016],
        Arnold-Roche [2014], Roche [2018]

        <item>vdH-Lecerf [2009, 2013, 2015, 2019], Grenet-vdH-Lecerf [2015,
        2016]

        <item>Huang-Gao [2017], Huang [2019]
      </itemize>
    </shown>|<\hidden*>
      <strong|Modern implementations>

      <\itemize>
        <item>Monagan [2010\U] Maple

        <item>vdH-Lecerf [2009, 2015\U] Mathemagix
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    \;

    \;

    \;

    \;

    <\with|par-right|2tab|par-left|2tab>
      <\ornamented>
        <\ornamented>
          \;

          <center|<with|frame-recolor|#fa6|<\center>
            <larger|<strong|Part II>>

            Generalities
          </center>>>

          \;
        </ornamented>
      </ornamented>
    </with>

    \;
  </hidden>|<\hidden>
    <tit|Reduction to case with known bounds>

    \;

    <\specified-algorithm*>
      <hrule>

      <strong|Input:> a polynomial black box function
      <math|f<around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>

      <strong|Output:> the sparse interpolation <math|f<rsup|\<ast\>>> of
      <math|f>
    <|specified-algorithm*>
      <\enumerate>
        <item>Set initial bounds <math|T\<assign\>1> and <math|D\<assign\>1>
        for <math|t> and the total degree <math|d> of <math|f>

        <item>Determine the <with|color|#fa6|sparse interpolation>
        <math|f<rsup|\<ast\>>> of <math|f> <with|color|#fa6|using these
        bounds>

        <item>If <math|f=f<rsup|\<ast\>>> with high probability, then return
        <math|f<rsup|\<ast\>>>

        <item>Increase <math|T> and/or <math|D> and return to step 2
      </enumerate>
    </specified-algorithm*>
  </hidden>|<\hidden>
    <tit|<with|condensed-factor|0.97|<condensed|Reduction to approximate
    sparse interpolation>>>

    \;

    <\specified-algorithm*>
      <hrule>

      <strong|Input:> a polynomial black box function
      <math|f<around*|(|x<rsub|1>,\<ldots\>,x<rsub|n>|)>>

      <strong|Output:> the sparse interpolation <math|f<rsup|\<ast\>>> of
      <math|f>
    <|specified-algorithm*>
      <\enumerate>
        <item>Let <math|f<rsup|\<ast\>>\<assign\>0> be an initial
        approximation of <math|f>

        <item>Determine the <with|color|#fa6|approximate sparse
        interpolation> <math|\<delta\><rsup|\<ast\>>> of
        <math|\<delta\>\<assign\>f-f<rsup|\<ast\>>>\ 

        <item>Set <math|f<rsup|\<ast\>>\<assign\>f<rsup|\<ast\>>+\<delta\><rsup|\<ast\>>>

        <item>If <math|f=f<rsup|\<ast\>>> with high probability, then return
        <math|f<rsup|\<ast\>>>

        <item>Return to step 3
      </enumerate>
    </specified-algorithm*>
  </hidden>|<\hidden>
    <tit|Finite fields>

    <unroll|<\shown>
      Unique finite field <math|\<bbb-F\><rsub|q>> of each size
      <math|q=p<rsup|n>>, with <math|p> prime and <math|n\<in\>\<bbb-N\>>
    </shown>|<\hidden*>
      <strong|Defining equation>

      We have <math|\<alpha\><rsup|q-1>=1> for all
      <math|\<alpha\>\<in\>\<bbb-F\><rsub|q><rsup|\<ast\>>>, whence
      <math|f=f<space|0.6spc> rem <around*|(|x<rsub|1><rsup|q-1>-1,\<ldots\>,x<rsub|n><rsup|q-1>-1|)>>
    </hidden*>|<\hidden*>
      <vspace*|0.5fn><strong|Roots of unity>

      <math|\<bbb-F\><rsub|q><rsup|\<ast\>>> is a cyclic group of order
      <math|q-1> <math|\<Longrightarrow\>> <math|\<exists\>> primitive root
      of unity of order <math|q-1>

      <\compressed>
        <\itemize>
          <item>Usually, <math|q-1> admits a few small prime divisors

          <item>If <math|n> is smooth, then <math|q-1> usually admits many
          small prime divisors

          <math|2<rsup|60>-1=3<rsup|2>\<cdot\>5<rsup|2>\<cdot\>7\<cdot\>11\<cdot\>13\<cdot\>31\<cdot\>41\<cdot\>61\<cdot\>151\<cdot\>331\<cdot\>1321>
        </itemize>
      </compressed>
    </hidden*>|<\hidden*>
      <\compressed>
        <vspace*|1fn><strong|Frobenius automorphisms>
        <math|<around*|(|a*b|)><rsup|q>=a<rsup|q>*b<rsup|q>,<around*|(|a+b|)><rsup|q>=a<rsup|q>+b<rsup|q>>

        <\eqnarray*>
          <tformat|<table|<row|<cell|\<phi\>:\<bbb-F\><rsub|q<rsup|s>>>|<cell|\<longrightarrow\>>|<cell|\<bbb-F\><rsub|q<rsup|s>>>>|<row|<cell|a>|<cell|\<longmapsto\>>|<cell|a<rsup|q>>>>>
        </eqnarray*>
      </compressed>
    </hidden*>>
  </hidden>|<\hidden>
    \;

    \;

    \;

    <\with|par-right|2tab|par-left|2tab>
      <\ornamented>
        <\ornamented>
          \;

          <center|<with|frame-recolor|#fa6|<\center>
            <larger|<strong|Part III>>

            The cyclic extension approach

            (Univariate case)
          </center>>>

          \;
        </ornamented>
      </ornamented>
    </with>

    \;

    \;
  </hidden>|<\hidden>
    <tit|Idea>

    \;

    <unroll|<\shown>
      <\equation*>
        f=c<rsub|1>*x<rsup|e<rsub|1>>+\<cdots\>+c<rsub|t>*x<rsup|e<rsub|t>>
      </equation*>
    </shown>|<\hidden*>
      <\compressed>
        <strong|Main idea>

        For pairwise coprime <math|r=r<rsub|1>,r<rsub|2>,\<ldots\>>, evaluate
        <math|f> at <math|<wide|x|\<bar\>>\<in\>K<around*|[|x|]>/<around*|(|x<rsup|r>-1|)>>,
        which yields

        <\equation*>
          f<space|0.8spc>rem <around*|(|x<rsup|r>-1|)>=c<rsub|1>*x<rsup|e<rsub|1>
          rem r>+\<cdots\>+c<rsub|t>*x<rsup|e<rsub|t> rem r>
        </equation*>

        Match corresponding terms and reconstruct <math|f> using Chinese
        remaindering
      </compressed>
    </hidden*>|<\hidden*>
      <vspace*|1fn><strong|Diversification>

      <\compressed>
        Several ways to \Pmatch corresponding terms\Q

        Easiest approach: assume that <math|c<rsub|1>,\<ldots\>,c<rsub|t>>
        are (almost all) pairwise distinct

        <math|\<alpha\>> is random and <math|<around*|\||K|\|>> large
        <math|\<Longrightarrow\>> <math|f<around*|(|\<alpha\>*x|)>> is
        diversified with high probability
      </compressed>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Example>

    <\compact>
      <switch|<\shown>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|2>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+*7+11|)>>*x+<with|color|red|<around*|(|18+33+1+4+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|3>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+1|)>>*x<rsup|2>+<with|color|red|<around*|(|18+33+7+4|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|5>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+11|)>>*x<rsup|3>+<with|color|red|<around*|(|33+2+1|)>>*x<rsup|2>+<with|color|green|7>*x+<with|color|red|<around*|(|18+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|7>-1|)>>|<cell|=>|<cell|<with|color|green|4>*x<rsup|6>+<calc-inert|field1|<with|color|red|<around*|(|18+1|)>>>*x<rsup|5>+<with|color|green|7>*x<rsup|2>+<with|color|red|<around*|(|33+2|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>
      </shown>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<table|<row|<cell|f>|<cell|=>|<cell|<marked|18*x<rsup|<with|color|cyan|250>>>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|2>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+*7+11|)>>*x+<with|color|red|<around*|(|18+33+1+4+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|3>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+1|)>>*x<rsup|2>+<with|color|red|<around*|(|18+33+7+4|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|5>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+11|)>>*x<rsup|3>+<with|color|red|<around*|(|33+2+1|)>>*x<rsup|2>+<with|color|green|7>*x+<with|color|red|<around*|(|18+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|7>-1|)>>|<cell|=>|<cell|<with|color|green|4>*x<rsup|6>+<calc-inert|field1|<with|color|red|<around*|(|18+1|)>>>*x<rsup|5>+<with|color|green|7>*x<rsup|2>+<with|color|red|<around*|(|33+2|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<marked|<with|color|green|18>*x<rsup|<with|color|cyan|3>>>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<marked|<with|color|green|18>*x<rsup|<with|color|cyan|3>>>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<marked|<with|color|green|18>*x<rsup|<with|color|cyan|20>>>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<marked|<with|color|green|18>*x<rsup|<with|color|cyan|18>>>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<marked|<with|color|green|18>*x<rsup|<with|color|cyan|2>>>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<marked|<with|color|green|18>*x<rsup|<with|color|cyan|28>>>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<marked|<with|color|green|18>*x<rsup|<with|color|cyan|4>>>+<with|color|green|28>>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|5|1|-1|cell-background|#440000>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|2>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+*7+11|)>>*x+<with|color|red|<around*|(|18+33+1+4+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|3>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+1|)>>*x<rsup|2>+<with|color|red|<around*|(|18+33+7+4|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|5>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+11|)>>*x<rsup|3>+<with|color|red|<around*|(|33+2+1|)>>*x<rsup|2>+<with|color|green|7>*x+<with|color|red|<around*|(|18+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|7>-1|)>>|<cell|=>|<cell|<with|color|green|4>*x<rsup|6>+<calc-inert|field1|<with|color|red|<around*|(|18+1|)>>>*x<rsup|5>+<with|color|green|7>*x<rsup|2>+<with|color|red|<around*|(|33+2|)>>*x+<with|color|red|<around*|(|11+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<cwith|1|-1|2|-1|color|#faa>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|modulo>|<cell|1>|<cell|1>|<cell|1>|<cell|1>|<cell|1>|<cell|1>|<cell|1>|<cell|1>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|3|5|color|orange>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|0>|<cell|1>|<cell|10>|<cell|9>|<cell|0>|<cell|0>|<cell|0>|<cell|0>>|<row|<cell|modulo>|<cell|1>|<cell|11>|<cell|11>|<cell|11>|<cell|1>|<cell|1>|<cell|1>|<cell|1>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|9|9|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|3>|<cell|1>|<cell|54>|<cell|9>|<cell|4>|<cell|1>|<cell|0>|<cell|0>>|<row|<cell|modulo>|<cell|13>|<cell|11>|<cell|143>|<cell|143>|<cell|13>|<cell|13>|<cell|1>|<cell|13>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<cwith|4|4|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|3|3|color|yellow>|<cwith|1|-1|6|6|color|yellow>|<cwith|1|-1|9|9|color|yellow>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|3>|<cell|45>|<cell|197>|<cell|9>|<cell|121>|<cell|1>|<cell|0>|<cell|0>>|<row|<cell|modulo>|<cell|13>|<cell|187>|<cell|2431>|<cell|143>|<cell|187>|<cell|13>|<cell|1>|<cell|187>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<cwith|4|4|1|-1|cell-background|#004400>|<cwith|5|5|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|3|3|color|yellow>|<cwith|1|-1|6|6|color|yellow>|<cwith|1|-1|9|9|color|yellow>|<cwith|1|-1|2|2|color|yellow>|<cwith|1|-1|8|8|color|orange>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|3>|<cell|45>|<cell|197>|<cell|9>|<cell|121>|<cell|1>|<cell|6>|<cell|0>>|<row|<cell|modulo>|<cell|247>|<cell|187>|<cell|2431>|<cell|143>|<cell|187>|<cell|13>|<cell|19>|<cell|187>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<cwith|4|4|1|-1|cell-background|#004400>|<cwith|5|5|1|-1|cell-background|#004400>|<cwith|6|6|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|3|3|color|yellow>|<cwith|1|-1|2|2|color|yellow>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<cwith|1|-1|4|4|color|green>|<cwith|1|-1|6|6|color|green>|<cwith|1|-1|9|9|color|green>|<cwith|1|-1|7|8|color|yellow>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|250>|<cell|232>|<cell|197>|<cell|153>|<cell|121>|<cell|118>|<cell|63>|<cell|0>>|<row|<cell|modulo>|<cell|5681>|<cell|4301>|<cell|55913>|<cell|3289>|<cell|4301>|<cell|299>|<cell|437>|<cell|4301>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<cwith|4|4|1|-1|cell-background|#004400>|<cwith|5|5|1|-1|cell-background|#004400>|<cwith|6|6|1|-1|cell-background|#004400>|<cwith|7|7|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|3|3|color|yellow>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<cwith|1|-1|6|6|color|green>|<cwith|1|-1|9|9|color|green>|<cwith|1|-1|7|8|color|yellow>|<cwith|1|-1|2|2|color|green>|<cwith|1|-1|4|4|color|#afa>|<cwith|1|-1|5|5|color|green>|<cwith|1|-1|7|7|color|green>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|250>|<cell|232>|<cell|197>|<cell|153>|<cell|121>|<cell|118>|<cell|63>|<cell|0>>|<row|<cell|modulo>|<cell|164749>|<cell|4301>|<cell|\<gtr\>10<rsup|6>>|<cell|95381>|<cell|4301>|<cell|8671>|<cell|437>|<cell|4301>>>>>
      </hidden>|<\hidden>
        <\eqnarray*>
          <tformat|<cwith|1|1|2|2|cell-bsep|2spc>|<cwith|2|2|1|-1|cell-background|#004400>|<cwith|3|3|1|-1|cell-background|#004400>|<cwith|4|4|1|-1|cell-background|#004400>|<cwith|5|5|1|-1|cell-background|#004400>|<cwith|6|6|1|-1|cell-background|#004400>|<cwith|7|7|1|-1|cell-background|#004400>|<cwith|8|8|1|-1|cell-background|#004400>|<table|<row|<cell|f>|<cell|=>|<cell|18*x<rsup|250>+33*x<rsup|232>+2*x<rsup|197>+x<rsup|152>+7*x<rsup|121>+4*x<rsup|118>+11*x<rsup|63>+28>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|11>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|10>+<with|color|green|1>*x<rsup|9>+<with|color|red|<around*|(|18+4+11|)>>*x<rsup|8>+<with|color|green|33>*x+<with|color|red|<around*|(|28+7|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|13>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|33+11|)>>*x<rsup|11>+<with|color|green|1>*x<rsup|9>+<with|color|green|7>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|green|2>*x<rsup|2>+<with|color|green|4>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|17>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|4+1|)>>*x<rsup|16>+<with|color|red|<around*|(|18+11|)>>*x<rsup|12>+<with|color|green|33>*x<rsup|11>+<with|color|green|2>*x<rsup|10>+<with|color|green|7>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|19>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|2+7|)>>*x<rsup|7>+<with|color|green|11>*x<rsup|6>+<with|color|red|<around*|(|33+4|)>>*x<rsup|4>+<with|color|green|18>*x<rsup|3>+<with|color|red|<around*|(|28+1|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|23>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|20>+<with|color|green|11>*x<rsup|17>+<with|color|green|1>*x<rsup|14>+<with|color|green|2>*x<rsup|13>+<with|color|green|7>*x<rsup|6>+<with|color|green|4>*x<rsup|3>+<with|color|green|33>*x<rsup|2>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|29>-1|)>>|<cell|=>|<cell|<with|color|green|2>*x<rsup|23>+<with|color|green|18>*x<rsup|18>+<with|color|green|1>*x<rsup|7>+<with|color|red|<around*|(|7+11|)>>*x<rsup|5>+<with|color|green|4>*x<rsup|2>+<with|color|red|<around*|(|33+28|)>>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|31>-1|)>>|<cell|=>|<cell|<with|color|red|<around*|(|1+7|)>>*x<rsup|28>+<with|color|green|4>*x<rsup|25>+<with|color|green|33>*x<rsup|15>+<with|color|green|2>*x<rsup|11>+<with|color|green|18>*x<rsup|2>+<with|color|green|11>*x+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|37>-1|)>>|<cell|=>|<cell|<with|color|green|18>*x<rsup|28>+<with|color|green|11>*x<rsup|26>+<with|color|green|2>*x<rsup|12>+<with|color|red|<around*|(|33+7|)>>*x<rsup|10>+<with|color|green|4>*x<rsup|7>+<with|color|green|1>*x<rsup|4>+<with|color|green|28>>>|<row|<cell|f<space|0.6spc>
          mod <around*|(|x<rsup|41>-1|)>>|<cell|=>|<cell|<with|color|green|7>*x<rsup|39>+<with|color|green|4>*x<rsup|36>+<with|color|green|2>*x<rsup|33>+<with|color|green|1>*x<rsup|29>+<with|color|green|33>*x<rsup|27>+<with|color|green|11>*x<rsup|22>+<with|color|green|18>*x<rsup|4>+<with|color|green|28>>>>>
        </eqnarray*>

        <block*|<tformat|<twith|table-width|1par>|<twith|table-hmode|exact>|<cwith|1|-1|1|1|cell-halign|l>|<cwith|1|-1|2|-1|color|red>|<cwith|1|-1|2|7|color|orange>|<cwith|1|-1|4|5|color|yellow>|<cwith|1|-1|2|-1|cell-width|0.1par>|<cwith|1|-1|2|-1|cell-hmode|exact>|<cwith|1|-1|6|6|color|green>|<cwith|1|-1|9|9|color|green>|<cwith|1|-1|7|8|color|yellow>|<cwith|1|-1|4|4|color|#afa>|<cwith|1|-1|5|5|color|green>|<cwith|1|-1|7|7|color|green>|<cwith|1|-1|2|2|color|#afa>|<cwith|1|-1|3|3|color|green>|<cwith|1|-1|8|8|color|green>|<table|<row|<cell|coefficient>|<cell|18>|<cell|33>|<cell|2>|<cell|1>|<cell|7>|<cell|4>|<cell|11>|<cell|28>>|<row|<cell|exponent>|<cell|250>|<cell|232>|<cell|197>|<cell|153>|<cell|121>|<cell|118>|<cell|63>|<cell|0>>|<row|<cell|modulo>|<cell|\<gtr\>10<rsup|6>>|<cell|133331>|<cell|\<gtr\>10<rsup|6>>|<cell|95381>|<cell|4301>|<cell|268801>|<cell|13547>|<cell|133331>>>>>
      </hidden>>
    </compact>
  </hidden>|<\hidden>
    <tit|The algorithm>

    \;

    <\specified-algorithm*>
      <hrule>

      <label|GS-algo><strong|Input:> a black box polynomial
      <math|f<around*|(|x|)>>, a degree bound <math|D>, a sparsity bound
      <math|T>

      <strong|Output:> a partial sparse interpolation <math|f<rsup|\<ast\>>>
      of <math|f>
    <|specified-algorithm*>
      <\enumerate>
        <item>Determine suitable moduli <math|r<rsub|1>,\<ldots\>,r<rsub|l>\<gtr\>T>
        with <math|lcm<around*|(|r<rsub|1>,\<ldots\>,r<rsub|l>|)>\<gtr\>D>

        <item>Evaluate <math|f> at <math|x> in
        <math|K<around*|[|x|]>/<around*|(|x<rsup|r<rsub|i>>-1|)>> for
        <math|i=1,\<ldots\>,l>

        <item>Determine matching terms in the expansions of
        <math|f<rsup|<around*|[|r<rsub|1>|]>>,\<ldots\>,f<rsup|<around*|[|r<rsub|l>|]>>>

        (likely from the same term <math|c<rsub|i>*x<rsup|e<rsub|i>>> in the
        expansion of <math|f>)

        <item>Return the sum <math|f<rsup|\<ast\>>> of all terms
        <math|c<rsub|i>*x<rsup|e<rsub|i>>> as above
      </enumerate>
    </specified-algorithm*>
  </hidden>|<\hidden>
    <tit|Probabilistic variant>

    <\specified-algorithm*>
      <hrule>

      <label|div-algo><strong|Input:> a diversified black box polynomial
      <math|f<around*|(|x|)>>, suitable moduli
      <math|r<rsub|1>,r<rsub|2>,\<ldots\>,r<rsub|l>>

      <strong|Output:> an approximate sparse interpolation
      <math|f<rsup|\<ast\>>> of <math|f>
    <|specified-algorithm*>
      <\enumerate>
        <item>Compute <math|f<rsup|<around*|[|r<rsub|k>|]>>=f rem
        <around*|(|x<rsup|r<rsub|k>>-1|)>> for <math|k=1,\<ldots\>,l>.

        <item>Let <math|f<rsup|\<ast\>>\<assign\>0>.

        <item>Let <math|\<cal-C\><rsub|k>\<assign\>>set of all coefficients
        that occur once in <math|f<rsup|<around*|[|r<rsub|k>|]>>>, for
        <math|k=1,\<ldots\>,l>.

        <item>For each <math|c\<in\>\<cal-C\><rsub|1>\<cup\>\<cdots\>\<cup\>\<cal-C\><rsub|l>>
        do:

        <\indent>
          If <math|\<cal-K\>\<assign\><around*|{|k\<suchthat\>c\<in\>\<cal-C\><rsub|k>|}>>
          is such that <math|lcm<around*|(|r<rsub|k>\<suchthat\>k\<in\>\<cal-K\>|)>\<gtr\>D>,
          then:

          <\indent>
            Determine the unique exponent <math|e\<less\>D> such that
            <math|c*x<rsup|e rem r<rsub|k>>> occurs
            in<nbsp><math|f<rsup|<around*|[|r<rsub|k>|]>>> for every
            <math|k\<in\>\<cal-K\>>, and set
            <math|f<rsup|\<ast\>>\<assign\>f<rsup|\<ast\>>+c*x<rsup|e>>.
          </indent>
        </indent>

        <item>Return <math|f<rsup|\<ast\>>>.
      </enumerate>
    </specified-algorithm*>
  </hidden>|<\hidden>
    <tit|Probabilistic analysis>

    \;

    <unroll|<\shown>
      <strong|Heuristic assumption>

      When reducing <math|f<around*|(|x|)>> modulo <math|x<rsup|r>-1>, the
      modular reductions of exponents <math|e<rsub|i> rem r> are uniformly
      distributed in <math|<around*|{|0,\<ldots\>,r-1|}>><vspace|0.5fn>
    </shown>|<\hidden*>
      <strong|Throwing <math|t> balls in <math|r> boxes>

      <\itemize>
        <unroll|<\shown>
          <item>Probability that a ball ends up in a box of its own:

          <\equation*>
            <around*|(|1-<frac|1|r>|)><rsup|t-1>\<approx\><around*|(|1-<frac|1|r>|)><rsup|t>=\<mathe\><rsup|log<around*|(|1-<frac|1|r>|)>*t>=\<mathe\><rsup|<around*|(|-<frac|1|r>-<frac|1|2*r<rsup|2>>+\<cdots\>|)>*t>\<approx\>\<mathe\><rsup|-t/r>
          </equation*>
        </shown>|<\hidden*>
          <item>On average, we obtain <math|\<mathe\><rsup|-t/r>*t>
          non-colliding terms when evaluating <math|f<around*|(|x|)> rem
          <around*|(|x<rsup|r>-1|)>>.
        </hidden*>>
      </itemize>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Complexity analysis>

    <unroll|<\shown>
      <\itemize>
        <unroll|<\shown>
          <item><math|L>: number of operations needed to evaluate <math|f>
        </shown>|<\hidden*>
          <item><math|M<around*|(|n|)>=O<rsup|\<flat\>><around*|(|n*log
          n|)>>: cost to multiply two polynomials of degree
          <math|\<leqslant\>n>
        </hidden*>|<\hidden*>
          <item>Cost of one evaluation <math|f<around*|(|x|)> rem
          <around*|(|x<rsup|r>-1|)>> is <math|O<around*|(|L*<math-ss|M><around*|(|r|)>|)>>
        </hidden*>|<\hidden*>
          <item>Expected number of correct terms:
          <math|\<mathe\><rsup|-t/r>*t>
        </hidden*>|<\hidden*>
          <item>Cost per correct term proportional to
          <math|r*\<mathe\><rsup|t/r>>
        </hidden*>|<\hidden*>
          <item>Optimum obtained by taking
          <math|r<rsub|1>\<approx\>\<cdots\>\<approx\>r<rsub|l>\<approx\>t>
        </hidden*>>
      </itemize>
    </shown>|<\hidden*>
      <\render-theorem|Proposition (modulo heuristic hypothesis)>
        Given <math|0\<less\>\<eta\>\<less\>1> and a diversified polynomial
        <math|f\<in\>\<bbb-F\><rsub|q><around*|[|x|]>> of degree
        <math|d\<leqslant\>D> and with <math|t\<leqslant\>T> terms, there
        exists a Monte Carlo probabilistic algorithm which computes at least
        <math|<around*|(|1-\<eta\>|)>*t> terms of <math|f> in time

        <\equation*>
          O<rsup|\<flat\>><around*|(|L*T*log D*log <around*|(|q*T|)>|)>.
        </equation*>
      </render-theorem>
    </hidden*>>
  </hidden>|<\hidden>
    \;

    \;

    \;

    <\with|par-right|2tab|par-left|2tab>
      <\ornamented>
        <\ornamented>
          \;

          <center|<with|frame-recolor|#fa6|<\center>
            <larger|<strong|Part IV>>

            The geometric progression approach

            (Univariate case)
          </center>>>

          \;
        </ornamented>
      </ornamented>
    </with>

    \;

    \;

    \;
  </hidden>|<\hidden>
    <tit|The method>

    <unroll|<\shown>
      <\equation*>
        f=c<rsub|1>*x<rsup|e<rsub|1>>+\<cdots\>+c<rsub|t>*x<rsup|e<rsub|t>>\<in\>\<bbb-F\><rsub|q><around*|[|x|]>
      </equation*>
    </shown>|<\hidden*>
      <switch|<\shown>
        <\compressed>
          For some number <math|\<omega\>\<in\>K> of high multiplicative
          order, compute

          <\eqnarray*>
            <tformat|<cwith|4|4|1|-1|cell-bborder|0ln>|<table|<row|<cell|f<around*|(|\<omega\><rsup|0>|)>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|0*e<rsub|1>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|0*e<rsub|t>>>>|<row|<cell|f<around*|(|\<omega\><rsup|1>|)>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|1*e<rsub|1>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|1*e<rsub|t>>>>|<row|<cell|f<around*|(|\<omega\><rsup|2>|)>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|2*e<rsub|1>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|2*e<rsub|t>>>>|<row|<cell|>|<cell|\<vdots\>>|<cell|>>>>
          </eqnarray*>
        </compressed>
      </shown>|<\hidden>
        <\compressed>
          For some number <math|\<omega\>\<in\>K> of high multiplicative
          order, compute

          <\eqnarray*>
            <tformat|<cwith|4|4|1|-1|cell-bborder|0ln>|<table|<row|<cell|f<around*|(|\<omega\><rsup|0>|)>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|0*e<rsub|1>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|0*e<rsub|t>>>>|<row|<cell|f<around*|(|\<omega\><rsup|1>|)>*<with|color|#fa6|z>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|1*e<rsub|1>>*<with|color|#fa6|z>+\<cdots\>+c<rsub|t>*\<omega\><rsup|1*e<rsub|t>>*<with|color|#fa6|z>>>|<row|<cell|f<around*|(|\<omega\><rsup|2>|)>*<with|color|#fa6|z<rsup|2>>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|2*e<rsub|1>>*<with|color|#fa6|z<rsup|2>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|2*e<rsub|t>>*<with|color|#fa6|z<rsup|2>>>>|<row|<cell|>|<cell|\<vdots\>>|<cell|>>>>
          </eqnarray*>
        </compressed>
      </hidden>|<\hidden>
        <\compressed>
          For some number <math|\<omega\>\<in\>K> of high multiplicative
          order, compute

          <\eqnarray*>
            <tformat|<cwith|4|4|1|-1|cell-bborder|0ln>|<table|<row|<cell|f<around*|(|\<omega\><rsup|0>|)>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|0*e<rsub|1>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|0*e<rsub|t>>>>|<row|<cell|f<around*|(|\<omega\><rsup|1>|)>*<with|color|#fa6|z>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|1*e<rsub|1>>*<with|color|#fa6|z>+\<cdots\>+c<rsub|t>*\<omega\><rsup|1*e<rsub|t>>*<with|color|#fa6|z>>>|<row|<cell|f<around*|(|\<omega\><rsup|2>|)>*<with|color|#fa6|z<rsup|2>>>|<cell|=>|<cell|c<rsub|1>*\<omega\><rsup|2*e<rsub|1>>*<with|color|#fa6|z<rsup|2>>+\<cdots\>+c<rsub|t>*\<omega\><rsup|2*e<rsub|t>>*<with|color|#fa6|z<rsup|2>>>>|<row|<cell|>|<cell|\<vdots\>>|<cell|>>|<row|<cell|<big|sum><rsub|k=0><rsup|\<infty\>>f<around*|(|\<omega\><rsup|k>|)>*<with|color|#fa6|z<rsup|k>>>|<cell|=>|<cell|<frac|c<rsub|1>|1-\<omega\><rsup|e<rsub|1>>*<with|color|#fa6|z>>+\<cdots\>+<frac|c<rsub|t>|1-\<omega\><rsup|e<rsub|t>>*<with|color|#fa6|z>>=<frac|N<around*|(|<with|color|#fa6|z>|)>|\<Lambda\><around*|(|<with|color|#fa6|z>|)>>>>>>
          </eqnarray*>
        </compressed>
      </hidden>>
    </hidden*>|<\hidden*>
      <\itemize>
        <\compressed>
          <unroll|<\shown>
            <item>Recover <math|N> and <math|\<Lambda\>> from the first
            <math|2*t-1> evaluations
          </shown>|<\hidden*>
            <item>Determine the roots <math|\<omega\><rsup|-e<rsub|i>>> of
            <math|\<Lambda\>>
          </hidden*>|<\hidden*>
            <item>Compute the discrete logarithms <math|e<rsub|i>> of
            <math|\<omega\><rsup|e<rsub|i>>> w.r.t. <math|\<omega\>>
          </hidden*>|<\hidden*>
            <item>Compute the coefficients <math|c<rsub|i>> using linear
            algebra
          </hidden*>>
        </compressed>
      </itemize>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Complexity analysis>

    <\with|par-par-sep|0.5fn>
      <\itemize>
        <unroll|<\shown>
          <item>Evaluate <math|f<around*|(|\<omega\><rsup|0>|)>,f<around*|(|\<omega\><rsup|1>|)>,\<ldots\>,f<around*|(|\<omega\><rsup|2*T-1>|)>><htab|5mm><math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|L*T*log
          q|)>>>
        </shown>|<\hidden*>
          <item>Recover <math|N> and <math|\<Lambda\>>

          <\itemize>
            <item>Half-gcd<htab|5mm><tiny-switch|<shown|<math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|M<rsub|q><around*|(|T|)>*log
            T|)>>>>|<hidden|<math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|T*<around*|(|log
            T|)><rsup|2>*log q|)>>>>>
          </itemize>
        </hidden*>|<\hidden*>
          <item>Determine the roots <math|\<omega\><rsup|-e<rsub|i>>> of
          <math|\<Lambda\>>

          <\compact>
            <\itemize>
              <item>Cantor\UZassenhaus<htab|5mm><math|O<rsup|\<flat\>><around*|(|T*<around*|(|log
              T|)><rsup|2>*<around*|(|log q|)><rsup|2>|)>>

              <item>Graeffe + <math|q-1> large smooth
              factor<htab|5mm><math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|T*<around*|(|log
              T|)><rsup|3>*log q|)>>>

              <item>Tangent-Graeffe + <math|q-1> large smooth
              factor<htab|5mm><math|O<rsup|\<flat\>><around*|(|T*<around*|(|log
              T|)><rsup|2>*log q|)>>
            </itemize>
          </compact>
        </hidden*>|<\hidden*>
          <item>Compute the discrete logarithms <math|e<rsub|i>> of
          <math|\<omega\><rsup|e<rsub|i>>> w.r.t. <math|\<omega\>>

          <\itemize>
            <item>Pohlig-Helmann + <math|q-1> large smooth
            factor<htab|5mm><math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|T*log
            T*log q|)>>>
          </itemize>
        </hidden*>|<\hidden*>
          <item>Compute the coefficients <math|c<rsub|i>> using linear
          algebra

          <\itemize>
            <item>Transposed fast multi-point
            interpolation<htab|5mm><math|<with|color|#fa6|O<rsup|\<flat\>><around*|(|T*<around*|(|log
            T|)><rsup|2>*log q|)>>>
          </itemize>
        </hidden*>|<\hidden*>
          <\compact>
            <hrule>

            <strong|Total><htab|5mm><math|<with|color|#fa6|O<around*|(|<around*|(|L+<around*|(|log
            T|)><rsup|3>|)>*T*log q|)>>>
          </compact>
        </hidden*>>
      </itemize>
    </with>

    \;
  </hidden>|<\hidden>
    <tit|Conclusion so far>

    <\with|par-par-sep|0.5fn>
      \;
    </with>

    <unroll|<\shown>
      <\render-theorem|Proposition (modulo suitable smoothness assumptions)>
        <\compact>
          We can compute the sparse interpolate of <math|f> in time

          <\equation*>
            O<rsup|\<flat\>><around*|(|<around*|(|L+<around*|(|log
            T|)><rsup|3>|)>*T*<around*|(|<with|math-display|false|<frac|log
            D|log T>>|)><rsup|3>*log <around*|(|q*T|)>|)>.
          </equation*>
        </compact>
      </render-theorem>
    </shown>|<\hidden*>
      <\itemize>
        <\compressed>
          <unroll|<\shown>
            <item>If <math|q\<less\>2*T>, then we need to replace <math|K> by
            <math|\<bbb-F\><rsub|q<rsup|s>>> for
            <math|s\<geqslant\><around*|\<lceil\>|<frac|log T|log
            q>|\<rceil\>>>

            <item>Significantly smaller hidden constant in
            <math|O<rsup|\<flat\>>>
          </shown>|<\hidden*>
            <item>If <math|L\<geqslant\><around*|(|log T|)><rsup|3>>, then
            use geometric progression approach
          </hidden*>|<\hidden*>
            <item>If <math|L\<less\><around*|(|log T|)><rsup|3>>, then use
            cyclic extension approach
          </hidden*>|<\hidden*>
            <item>For <math|n\<times\>n> symbolic determinant:
            <math|L=n<rsup|3>> and <math|t=n!>
          </hidden*>>
        </compressed>
      </itemize>
    </hidden*>|<\hidden*>
      <vspace*|0.5fn><strong|Problems>

      <\compressed>
        <\itemize>
          <item>Can we reduce the <math|<around*|(|log T|)><rsup|3>>
          factor<space|0.6spc>?

          <item>If <math|q> is small, then can we avoid paying the extension
          factor <math|s\<geqslant\><around*|\<lceil\>|<frac|log T|log
          q>|\<rceil\>>><space|0.6spc>?
        </itemize>
      </compressed>
    </hidden*>>
  </hidden>|<\hidden>
    \;

    \;

    \;

    <\with|par-right|2tab|par-left|2tab>
      <\ornamented>
        <\ornamented>
          \;

          <center|<with|frame-recolor|#fa6|<\center>
            <larger|<strong|Part V>>

            FFT-based approach

            (Univariate case)
          </center>>>

          \;
        </ornamented>
      </ornamented>
    </with>

    \;
  </hidden>|<\hidden>
    <tit|Main idea>

    <unroll|<\shown>
      <\itemize>
        <item>Computation of <math|f<space|0.8spc>rem
        <around*|(|x<rsup|r>-1|)>> In cyclic extension method:

        <with|color|red|math-color|red|Evaluate <math|f> over
        <math|K<around*|[|x|]>/<around*|(|x<rsup|r>-1|)>>>
        <math|\<longrightarrow\>> <with|color|green|Use FFT (or Frobenius
        FFT)>
      </itemize>
    </shown>|<\hidden*>
      <strong|Most favorable case>

      <\itemize>
        <switch|<\shown>
          <item><math|r\<divides\><around*|(|q-1|)>> and <math|r\<approx\>T>,
          so that <math|x<rsup|r>-1=<around*|(|x-1|)>*<around*|(|x-\<omega\>|)>*\<cdots\>*<around*|(|x-\<omega\><rsup|r-1>|)>>
          for some <math|\<omega\>\<in\>\<bbb-F\><rsub|q>>
        </shown>|<\hidden>
          <item><math|r\<divides\><around*|(|q-1|)>> and <math|r\<approx\>T>,
          so that <math|x<rsup|r>-1=<around*|(|x-1|)>*<around*|(|x-\<omega\>|)>*\<cdots\>*<around*|(|x-\<omega\><rsup|r-1>|)>>
          for some <math|\<omega\>\<in\>\<bbb-F\><rsub|q>>

          <\equation*>
            f<space|0.6spc> rem <around*|(|x<rsup|r>-1|)><long-arrow|\<rubber-rightleftarrows\>|<text|FFT>|<math-ordinary|<text|Inverse
            FFT>>><around*|(|f<around*|(|1|)>,f<around*|(|\<omega\>|)>,\<ldots\>,f<around*|(|\<omega\><rsup|r-1>|)>|)>
          </equation*>
        </hidden>|<\hidden>
          <item><math|r\<divides\><around*|(|q-1|)>> and <math|r\<approx\>T>,
          so that <math|x<rsup|r>-1=<around*|(|x-1|)>*<around*|(|x-\<omega\>|)>*\<cdots\>*<around*|(|x-\<omega\><rsup|r-1>|)>>
          for some <math|\<omega\>\<in\>\<bbb-F\><rsub|q>>
        </hidden>>
      </itemize>
    </hidden*>|<\hidden*>
      <strong|Next favorable case>

      <\compressed>
        <\itemize>
          <item><math|r\<divides\><around*|(|q<rsup|s>-1|)>> and
          <math|r\<approx\>T> for a small <math|s>

          <item><math|x<rsup|r>-1> factors into polynomials of small degrees
          over <math|\<bbb-F\><rsub|q>>
        </itemize>
      </compressed>
    </hidden*>|<\hidden*>
      <\compressed>
        <vspace*|0.5fn><strong|Frobenius FFT>

        <\itemize>
          <item>If we need to evaluate <math|f\<in\>\<bbb-F\><rsub|q><around*|[|x|]>>
          over <math|\<bbb-F\><rsub|q<rsup|s>>> with <math|s\<gtr\>1>, then

          <\itemize>
            <item> <math|f<around*|(|\<alpha\><rsup|q>|)>=f<around*|(|\<alpha\>|)><rsup|q>>
            for all <math|\<alpha\>\<in\>\<bbb-F\><rsub|q<rsup|s>>>

            <item>Compute only one of the values
            <math|f<around*|(|\<omega\><rsup|i>|)>,f<around*|(|\<omega\><rsup|q*i>|)>,\<ldots\>,f<around*|(|\<omega\><rsup|q<rsup|s-1>*i>|)>>
            for each <math|i>

            <item>Use inverse Frobenius FFT to recover
            <math|f<space|0.8spc>rem <around*|(|x<rsup|r>-1|)>>
          </itemize>
        </itemize>
      </compressed>
    </hidden*>>

    \;
  </hidden>|<\hidden>
    <tit|Complexity analysis>

    <unroll|<\shown>
      <vspace*|0.5fn><strong|Most favorable case only<text-dots>>

      <\itemize>
        <item>We can pick sufficiently many coprime
        <math|r<rsub|1>,\<ldots\>,r<rsub|l>\<approx\>T><vspace|0.5fn>
      </itemize>
    </shown>|<\hidden*>
      <\render-theorem|Proposition (modulo many provisos)>
        <\compact>
          We can compute the sparse interpolation of
          <math|f\<in\>\<bbb-F\><rsub|q><around*|[|x|]>> in time

          <\equation*>
            O<rsup|\<flat\>><around*|(|<around*|(|L+log
            T|)>*T*<around*|(|<with|math-display|false|<frac|log D|log
            T>>|)><rsup|2>*log <around*|(|q*T|)>|)>
          </equation*>
        </compact>
      </render-theorem>
    </hidden*>|<\hidden*>
      <vspace*|0.5fn><strong|About constant factors>

      <\compressed>
        <\itemize>
          <item>The geometric progression method uses <math|2*T-1>
          evaluations

          <item>The FFT-based method uses <math|T> evaluations with success
          rate <math|\<mathe\><rsup|-1>>
        </itemize>
      </compressed>
    </hidden*>>
  </hidden>|<\hidden>
    <tit|Do good orders <math|r> exist<space|0.2spc>?>

    <strong|Example for <math|q=2<rsup|30>>, <math|T=10<rsup|6>>, and
    <math|D=10<rsup|18>>>

    <\equation*>
      <tabular*|<tformat|<cwith|1|-1|9|9|cell-halign|l>|<cwith|1|-1|5|5|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|-1|11|11|cell-halign|r>|<cwith|1|-1|13|13|cell-halign|l>|<cwith|6|6|11|11|cell-halign|r>|<cwith|6|6|13|13|cell-halign|l>|<cwith|7|7|11|11|cell-halign|r>|<cwith|7|7|13|13|cell-halign|l>|<cwith|7|7|11|11|cell-halign|r>|<cwith|7|7|13|13|cell-halign|l>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|13|13|cell-halign|l>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|13|13|cell-halign|l>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|13|13|cell-halign|l>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|13|13|cell-halign|l>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|13|13|cell-halign|l>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|13|13|cell-halign|l>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|13|13|cell-halign|l>|<cwith|3|10|7|7|cell-halign|l>|<cwith|4|6|11|11|cell-halign|r>|<cwith|7|9|11|11|cell-halign|r>|<table|<row|<cell|s<rsub|1>>|<cell|=>|<cell|1>|<cell|<space|2em>>|<cell|r<rsub|1>>|<cell|=>|<cell|1549411>|<cell|=>|<cell|31\<cdot\>151\<cdot\>331>|<cell|<space|2em>>|<cell|\<Lambda\><rsub|1>>|<cell|\<approx\>>|<cell|1.5\<cdot\>10<rsup|6>>>|<row|<cell|s<rsub|2>>|<cell|=>|<cell|2>|<cell|>|<cell|r<rsub|2>>|<cell|=>|<cell|1047553>|<cell|=>|<cell|13\<cdot\>61\<cdot\>1321>|<cell|>|<cell|\<Lambda\><rsub|2>>|<cell|\<approx\>>|<cell|1.6\<cdot\>10<rsup|12>>>|<row|<cell|s<rsub|3>>|<cell|=>|<cell|3>|<cell|>|<cell|r<rsub|3>>|<cell|=>|<cell|1701703>|<cell|=>|<cell|73\<cdot\>23311>|<cell|>|<cell|\<Lambda\><rsub|3>>|<cell|\<approx\>>|<cell|2.8\<cdot\>10<rsup|18>>>|<row|<cell|s<rsub|4>>|<cell|=>|<cell|3>|<cell|>|<cell|r<rsub|4>>|<cell|=>|<cell|1186911>|<cell|=>|<cell|3<rsup|2>\<cdot\>11\<cdot\>19\<cdot\>631>|<cell|>|<cell|\<Lambda\><rsub|4>>|<cell|\<approx\>>|<cell|3.2\<cdot\>10<rsup|24>>>|<row|<cell|s<rsub|5>>|<cell|=>|<cell|4>|<cell|>|<cell|r<rsub|5>>|<cell|=>|<cell|1048577>|<cell|=>|<cell|17\<cdot\>61681>|<cell|>|<cell|\<Lambda\><rsub|5>>|<cell|\<approx\>>|<cell|3.4\<cdot\>10<rsup|30>>>|<row|<cell|s<rsub|6>>|<cell|=>|<cell|4>|<cell|>|<cell|r<rsub|6>>|<cell|=>|<cell|1729175>|<cell|=>|<cell|5<rsup|2>\<cdot\>7\<cdot\>41\<cdot\>241>|<cell|>|<cell|\<Lambda\><rsub|6>>|<cell|\<approx\>>|<cell|5.9\<cdot\>10<rsup|36>>>|<row|<cell|s<rsub|7>>|<cell|=>|<cell|5>|<cell|>|<cell|r<rsub|7>>|<cell|=>|<cell|1016801>|<cell|=>|<cell|251\<cdot\>4051>|<cell|>|<cell|\<Lambda\><rsub|7>>|<cell|\<approx\>>|<cell|6.0\<cdot\>10<rsup|42>>>|<row|<cell|s<rsub|8>>|<cell|=>|<cell|5>|<cell|>|<cell|r<rsub|8>>|<cell|=>|<cell|1082401>|<cell|=>|<cell|601\<cdot\>1801>|<cell|>|<cell|\<Lambda\><rsub|8>>|<cell|\<approx\>>|<cell|6.5\<cdot\>10<rsup|48>>>|<row|<cell|s<rsub|9>>|<cell|=>|<cell|5>|<cell|>|<cell|r<rsub|9>>|<cell|=>|<cell|1108811>|<cell|=>|<cell|11\<cdot\>100801>|<cell|>|<cell|\<Lambda\><rsub|9>>|<cell|\<approx\>>|<cell|6.6\<cdot\>10<rsup|53>>>|<row|<cell|s<rsub|10>>|<cell|=>|<cell|6>|<cell|>|<cell|r<rsub|10>>|<cell|=>|<cell|1134021>|<cell|=>|<cell|3\<cdot\>7\<cdot\>54001>|<cell|>|<cell|\<Lambda\><rsub|10>>|<cell|\<approx\>>|<cell|3.6\<cdot\>10<rsup|58>>>>>>
    </equation*>

    \;

    <\equation*>
      \<Lambda\><rsub|i>\<assign\>lcm<around*|(|r<rsub|1>,\<ldots\>,r<rsub|i>|)>,<space|2em>D<rsup|\<mathe\>>\<approx\>8.5\<cdot\>10<rsup|48>
    </equation*>
  </hidden>|<\hidden>
    <tit|Do good orders <math|r> exist<space|0.2spc>?>

    <strong|Example for (prime) <math|q=1299743>, <math|T=10<rsup|6>>, and
    <math|D=10<rsup|18>>>

    <\equation*>
      <tabular*|<tformat|<cwith|1|-1|9|9|cell-halign|l>|<cwith|1|-1|5|5|cell-halign|r>|<cwith|1|-1|3|3|cell-halign|l>|<cwith|1|-1|11|11|cell-halign|r>|<cwith|1|-1|13|13|cell-halign|l>|<cwith|6|6|11|11|cell-halign|r>|<cwith|7|7|11|11|cell-halign|r>|<cwith|7|7|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|1|10|7|7|cell-halign|l>|<cwith|1|-1|1|1|cell-halign|r>|<cwith|1|10|11|11|cell-halign|r>|<cwith|6|6|11|11|cell-halign|r>|<cwith|7|7|11|11|cell-halign|r>|<cwith|7|7|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|8|8|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|9|9|11|11|cell-halign|r>|<cwith|4|6|11|11|cell-halign|r>|<cwith|7|9|11|11|cell-halign|r>|<table|<row|<cell|s<rsub|1>>|<cell|=>|<cell|1>|<cell|<space|2em>>|<cell|r<rsub|1>>|<cell|=>|<cell|1299742>|<cell|=>|<cell|2\<cdot\>649871>|<cell|<space|2em>>|<cell|\<Lambda\><rsub|1>>|<cell|\<approx\>>|<cell|1.3\<cdot\>10<rsup|6>>>|<row|<cell|s<rsub|2>>|<cell|=>|<cell|2>|<cell|>|<cell|r<rsub|2>>|<cell|=>|<cell|1299744>|<cell|=>|<cell|2<rsup|5>\<cdot\>3<rsup|2>\<cdot\>4513>|<cell|>|<cell|\<Lambda\><rsub|2>>|<cell|\<approx\>>|<cell|8.4\<cdot\>10<rsup|11>>>|<row|<cell|s<rsub|3>>|<cell|=>|<cell|4>|<cell|>|<cell|r<rsub|3>>|<cell|=>|<cell|1006325>|<cell|=>|<cell|5<rsup|2>\<cdot\>40253>|<cell|>|<cell|\<Lambda\><rsub|3>>|<cell|\<approx\>>|<cell|8.5\<cdot\>10<rsup|17>>>|<row|<cell|s<rsub|4>>|<cell|=>|<cell|4>|<cell|>|<cell|r<rsub|4>>|<cell|=>|<cell|1678714>|<cell|=>|<cell|2\<cdot\>193\<cdot\>4349>|<cell|>|<cell|\<Lambda\><rsub|4>>|<cell|\<approx\>>|<cell|7.1\<cdot\>10<rsup|23>>>|<row|<cell|s<rsub|5>>|<cell|=>|<cell|5>|<cell|>|<cell|r<rsub|5>>|<cell|=>|<cell|1690111>|<cell|=>|<cell|701\<cdot\>2411>|<cell|>|<cell|\<Lambda\><rsub|5>>|<cell|\<approx\>>|<cell|1.2\<cdot\>10<rsup|30>>>|<row|<cell|s<rsub|6>>|<cell|=>|<cell|6>|<cell|>|<cell|r<rsub|6>>|<cell|=>|<cell|1119937>|<cell|=>|<cell|7\<cdot\>13\<cdot\>31\<cdot\>397>|<cell|>|<cell|\<Lambda\><rsub|6>>|<cell|\<approx\>>|<cell|1.4\<cdot\>10<rsup|36>>>|<row|<cell|s<rsub|7>>|<cell|=>|<cell|8>|<cell|>|<cell|r<rsub|7>>|<cell|=>|<cell|1196324>|<cell|=>|<cell|2<rsup|2>\<cdot\>17\<cdot\>73\<cdot\>241>|<cell|>|<cell|\<Lambda\><rsub|7>>|<cell|\<approx\>>|<cell|4.0\<cdot\>10<rsup|41>>>|<row|<cell|s<rsub|8>>|<cell|=>|<cell|9>|<cell|>|<cell|r<rsub|8>>|<cell|=>|<cell|1185702>|<cell|=>|<cell|2\<cdot\>3\<cdot\>7<rsup|2>\<cdot\>37\<cdot\>109>|<cell|>|<cell|\<Lambda\><rsub|8>>|<cell|\<approx\>>|<cell|1.1\<cdot\>10<rsup|46>>>|<row|<cell|s<rsub|9>>|<cell|=>|<cell|10>|<cell|>|<cell|r<rsub|9>>|<cell|=>|<cell|1376122>|<cell|=>|<cell|2\<cdot\>11\<cdot\>71\<cdot\>881>|<cell|>|<cell|\<Lambda\><rsub|9>>|<cell|\<approx\>>|<cell|7.8\<cdot\>10<rsup|51>>>|<row|<cell|s<rsub|10>>|<cell|=>|<cell|11>|<cell|>|<cell|r<rsub|10>>|<cell|=>|<cell|3423619>|<cell|=>|<cell|23\<cdot\>148853>|<cell|>|<cell|\<Lambda\><rsub|10>>|<cell|\<approx\>>|<cell|2.7\<cdot\>10<rsup|58>>>>>>
    </equation*>
  </hidden>|<\hidden>
    \;

    <\center>
      <\with|par-par-sep|0.3333fn>
        <\center>
          <really-huge|<strong|<with|color|orange|Thank you !>>>
        </center>
      </with>

      <tabular|<tformat|<cwith|1|3|1|1|cell-halign|c>|<cwith|1|1|1|1|cell-tsep|4spc>|<cwith|1|1|1|1|cell-hyphen|t>|<table|<row|<\cell>
        <tabular*|<tformat|<cwith|1|1|1|1|cell-background|<pattern|/Users/vdhoeven/sdk-clang/src/TeXmacs/misc/patterns/vintage/metal-rough-light.png||>>|<cwith|1|1|1|1|cell-lsep|1spc>|<cwith|1|1|1|1|cell-rsep|1spc>|<cwith|1|1|1|1|cell-bsep|1spc>|<cwith|1|1|1|1|cell-tsep|1spc>|<table|<row|<cell|<image|transparent-texmacs-chip.png|0.5par|||>>>>>>
      </cell>>|<row|<cell|<strong|><center|>>>|<row|<cell|<with|color|#ffa|<verbatim|http://www.<anim-repeat|<anim-compose|<anim-constant|<with|color|orange|T<space|-0.2spc><with|color|orange|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc>><rsub|<with|math-level|0|font-shape|small-caps|ma<space|-0.2spc>cs>>|1sec>|<anim-constant|T<space|-0.2spc><with|color|orange|<rsub|<with|math-level|0|font-shape|small-caps|e>>>X<space|-0.2spc><with|color|orange|<rsub|<with|math-level|0|font-shape|small-caps|ma<space|-0.2spc>cs>>>|1sec>>>.org>>>>>>>
    </center>

    \;
  </hidden>>
</body>

<\initial>
  <\collection>
    <associate|font|Fira>
    <associate|font-family|rm>
    <associate|info-flag|none>
    <associate|locus-color|#aaf>
    <associate|magnification|2>
    <associate|ornament-vpadding|1spc>
    <associate|page-bot|-5mm>
    <associate|page-height|auto>
    <associate|page-medium|beamer>
    <associate|page-type|4:3>
    <associate|page-width|auto>
    <associate|preamble|false>
  </collection>
</initial>

<\references>
  <\collection>
    <associate|GS-algo|<tuple|<with|mode|<quote|math>|\<bullet\>>|15>>
    <associate|div-algo|<tuple|4|16>>
  </collection>
</references>